2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet] [<message>]]
19 TMP="$GIT_DIR/.git-stash.$$"
20 trap 'rm -f "$TMP-*"' 0
24 if git config --get-colorbool color.interactive; then
25 help_color="$(git config --get-color color.interactive.help 'red bold')"
26 reset_color="$(git config --get-color '' reset)"
33 git diff-index --quiet --cached HEAD --ignore-submodules -- &&
34 git diff-files --quiet --ignore-submodules
40 die "git stash clear with parameters is unimplemented"
42 if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
44 git update-ref -d $ref_stash $current
51 git update-index -q --refresh
57 # state of the base commit
58 if b_commit=$(git rev-parse --verify HEAD)
60 head=$(git log --no-color --abbrev-commit --pretty=oneline -n 1 HEAD --)
62 die "You do not have the initial commit yet"
65 if branch=$(git symbolic-ref -q HEAD)
67 branch=${branch#refs/heads/}
71 msg=$(printf '%s: %s' "$branch" "$head")
74 i_tree=$(git write-tree) &&
75 i_commit=$(printf 'index on %s\n' "$msg" |
76 git commit-tree $i_tree -p $b_commit) ||
77 die "Cannot save the current index state"
79 if test -z "$patch_mode"
82 # state of the working tree
85 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
86 GIT_INDEX_FILE="$TMP-index" &&
87 export GIT_INDEX_FILE &&
88 git read-tree -m $i_tree &&
89 git diff --name-only -z HEAD | git update-index -z --add --remove --stdin &&
93 die "Cannot save the current worktree state"
98 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
100 # find out what the user wants
101 GIT_INDEX_FILE="$TMP-index" \
102 git add--interactive --patch=stash -- &&
104 # state of the working tree
105 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
106 die "Cannot save the current worktree state"
108 git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
109 test -s "$TMP-patch" ||
110 die "No changes selected"
112 rm -f "$TMP-index" ||
113 die "Cannot remove temporary index (can't happen)"
118 if test -z "$stash_msg"
120 stash_msg=$(printf 'WIP on %s' "$msg")
122 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
124 w_commit=$(printf '%s\n' "$stash_msg" |
125 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
126 die "Cannot record working tree state"
153 echo "error: unknown option for 'stash save': $1"
154 echo " To provide a message, use git stash save -- '$1'"
166 git update-index -q --refresh
169 say 'No local changes to save'
172 test -f "$GIT_DIR/logs/$ref_stash" ||
173 clear_stash || die "Cannot initialize stash"
175 create_stash "$stash_msg"
177 # Make sure the reflog for stash is kept.
178 : >>"$GIT_DIR/logs/$ref_stash"
180 git update-ref -m "$stash_msg" $ref_stash $w_commit ||
181 die "Cannot save the current status"
182 say Saved working directory and index state "$stash_msg"
184 if test -z "$patch_mode"
186 git reset --hard ${GIT_QUIET:+-q}
188 if test -n "$keep_index" && test -n $i_tree
190 git read-tree --reset -u $i_tree
193 git apply -R < "$TMP-patch" ||
194 die "Cannot remove worktree changes"
196 if test -z "$keep_index"
204 git rev-parse --verify $ref_stash >/dev/null 2>&1
208 have_stash || return 0
209 git log --format="%gd: %gs" -g "$@" $ref_stash --
213 have_stash || die 'No stash found'
215 flags=$(git rev-parse --no-revs --flags "$@")
221 w_commit=$(git rev-parse --quiet --verify --default $ref_stash "$@") &&
222 b_commit=$(git rev-parse --quiet --verify "$w_commit^") ||
223 die "'$*' is not a stash"
225 git diff $flags $b_commit $w_commit
250 have_stash || die 'Nothing to apply'
251 applied_stash="$ref_stash@{0}"
256 # stash records the work tree, and is a merge between the
257 # base commit (first parent) and the index tree (second parent).
258 s=$(git rev-parse --quiet --verify --default $ref_stash "$@") &&
259 w_tree=$(git rev-parse --quiet --verify "$s:") &&
260 b_tree=$(git rev-parse --quiet --verify "$s^1:") &&
261 i_tree=$(git rev-parse --quiet --verify "$s^2:") ||
262 die "$*: no valid stashed state found"
264 git update-index -q --refresh &&
265 git diff-files --quiet --ignore-submodules ||
266 die 'Cannot apply to a dirty working tree, please stage your changes'
268 # current index state
269 c_tree=$(git write-tree) ||
270 die 'Cannot apply a stash in the middle of a merge'
272 unstashed_index_tree=
273 if test -n "$unstash_index" && test "$b_tree" != "$i_tree" &&
274 test "$c_tree" != "$i_tree"
276 git diff-tree --binary $s^2^..$s^2 | git apply --cached
278 die 'Conflicts in index. Try without --index.'
279 unstashed_index_tree=$(git write-tree) ||
280 die 'Could not save index tree'
285 GITHEAD_$w_tree='Stashed changes' &&
286 GITHEAD_$c_tree='Updated upstream' &&
287 GITHEAD_$b_tree='Version stash was based on' &&
288 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
291 if test -n "$GIT_QUIET"
293 export GIT_MERGE_VERBOSITY=0
295 if git merge-recursive $b_tree -- $c_tree $w_tree
298 if test -n "$unstashed_index_tree"
300 git read-tree "$unstashed_index_tree"
303 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
304 git read-tree --reset $c_tree &&
305 git update-index --add --stdin <"$a" ||
306 die "Cannot unstage modified files"
310 if test -n "$GIT_QUIET"
312 squelch='>/dev/null 2>&1'
314 eval "git status $squelch" || :
316 # Merge conflict; keep the exit status from merge-recursive
318 if test -n "$unstash_index"
320 echo >&2 'Index was not unstashed.'
327 have_stash || die 'No stash entries to drop'
344 set x "$ref_stash@{0}"
347 # Verify supplied argument looks like a stash entry
348 s=$(git rev-parse --verify "$@") &&
349 git rev-parse --verify "$s:" > /dev/null 2>&1 &&
350 git rev-parse --verify "$s^1:" > /dev/null 2>&1 &&
351 git rev-parse --verify "$s^2:" > /dev/null 2>&1 ||
352 die "$*: not a valid stashed state"
354 git reflog delete --updateref --rewrite "$@" &&
355 say "Dropped $* ($s)" || die "$*: Could not drop stash entry"
357 # clear_stash if we just dropped the last stash entry
358 git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
362 have_stash || die 'Nothing to apply'
364 test -n "$1" || die 'No branch name specified'
369 set x "$ref_stash@{0}"
373 git checkout -b $branch $stash^ &&
374 apply_stash --index $stash &&
378 # The default command is "save" if nothing but options are given
384 *) seen_non_option=t; break ;;
388 test -n "$seen_non_option" || set "save" "$@"
413 if test $# -gt 0 && test "$1" = create
417 create_stash "$*" && echo "$w_commit"
427 drop_stash "$applied_stash"
438 say '(To restore them type "git stash apply")'